/*****************************************************************************
 *	aisa37w.c
 *
 *	aISA-P37
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa37w.h"	// aISA-P37

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa37wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa37GetVersion;
static FARPROC pAisa37Create;
static FARPROC pAisa37Close;
static FARPROC pAisa37GetResource;
static FARPROC pAisa37InPort;
static FARPROC pAisa37OutPort;
static FARPROC pAisa37GetLastError;

BOOL Aisa37wDllOpen ( void )
/*****************************************************************************
 * @\  aisa37.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA37_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa37wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa37wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa37wDllClose ( void )
/*****************************************************************************
 * @\  aisa37.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa37wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-P37DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE		   --- 
 *		 FALSE		   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa37wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-P37̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37Create)(pwLogSlot);
}

BOOL Aisa37wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P37̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37Close)(wLogSlot);
}

BOOL Aisa37wGetResource ( WORD wLogSlot, PAISA37R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa37wInPort ( WORD wLogSlot, DWORD dwPort, PBYTE pbInValue )
/*****************************************************************************
 * @\  Cӂ̃|[gf[^
 * 	 wLogSlot  --- ͂foCX
 *		 dwPort	   --- ͂|[g
 *		 pbInValue --- ̓f[^i[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37InPort)(wLogSlot, dwPort, pbInValue);
}

BOOL Aisa37wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa37OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa37wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P37̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA37_ERR_WRAPDLL;
	}
	return (*pAisa37GetLastError)(wLogSlot);
}

static BOOL Aisa37wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa37GetVersion ̃AhX擾
	pAisa37GetVersion = GetProcAddress(hDLL, _T("Aisa37GetVersion"));
	if (pAisa37GetVersion == NULL) {
		return FALSE;
	}

	// Aisa37Create ̃AhX擾
	pAisa37Create = GetProcAddress(hDLL, _T("Aisa37Create"));
	if (pAisa37Create == NULL) {
		return FALSE;
	}

	// Aisa37Close ̃AhX擾
	pAisa37Close = GetProcAddress(hDLL, _T("Aisa37Close"));
	if (pAisa37Close == NULL) {
		return FALSE;
	}

	// Aisa37GetResource ̃AhX擾
	pAisa37GetResource = GetProcAddress(hDLL, _T("Aisa37GetResource"));
	if (pAisa37GetResource == NULL) {
		return FALSE;
	}

	// Aisa37InPort ̃AhX擾
	pAisa37InPort = GetProcAddress(hDLL, _T("Aisa37InPort"));
	if (pAisa37InPort == NULL) {
		return FALSE;
	}

	// Aisa37OutPort ̃AhX擾
	pAisa37OutPort = GetProcAddress(hDLL, _T("Aisa37OutPort"));
	if (pAisa37OutPort == NULL) {
		return FALSE;
	}

	// Aisa37GetLastError ̃AhX擾
	pAisa37GetLastError = GetProcAddress(hDLL, _T("Aisa37GetLastError"));
	if (pAisa37GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
